#include <D:\8051\ARM\REG7S256.h>

extern unsigned char buffer [25];	//  sprintf

void WaitLCD(void);
void WrCOM(unsigned int DATA);

const unsigned int table[];
//--------------------------------------------------------------------------------------------------------------------
void InitCE (void){					//    
	*PIO_CODR =  (0x7F00);			//    
    WrCOM(0x28); 					//28h - 4 -   
	WrCOM(0x0c); 					//Ch -  
	WrCOM(6); 						//6 -  
	WrCOM(1);}						//1 -  
//--------------------------------------------------------------------------------------------------------------------
void WrDAT(unsigned int DATA) {		// 
unsigned int Temp=0;				//  78   48
    WaitLCD();						//  LCD
	*PIO_CODR =  (0x7F00);			//    
	*PIO_SODR =  (1<<12);			// R/S
	Temp=(DATA>>4);					//  TEMP     
	*PIO_SODR = (Temp<<8); 			//    PA8-11
	*PIO_SODR =  (1<<14);			//    E (PA14)( 120   48)
	*PIO_CODR =  (0x6F00);			//       R/S
    Temp=(DATA & 0xF);				//  TEMP     
	*PIO_SODR = (Temp<<8); 			//    PA8-11
	*PIO_SODR =  (1<<14);			//    E (PA14)( 120   48)
	*PIO_CODR =  (0x7F00);	}		//    
//--------------------------------------------------------------------------------------------------------------------
void WrCOM(unsigned int DATA) {		// 
unsigned int Temp=0;				//  78   48
    WaitLCD();						//  LCD
	*PIO_CODR =  (0x7F00);			//    
	Temp=(DATA>>4);					//  TEMP     
	*PIO_SODR = (Temp<<8); 			//    PA8-11
	*PIO_SODR =  (1<<14);			//    E (PA14)( 120   48)
	*PIO_CODR =  (0x7F00);			//    
    Temp=(DATA & 0xF);				//  TEMP     
	*PIO_SODR = (Temp<<8); 			//    PA8-11
	*PIO_SODR =  (1<<14);			//    E (PA14)( 120   48)
	*PIO_CODR =  (0x7F00);	}		//    
//--------------------------------------------------------------------------------------------------------------------
void PrintBuf(unsigned int POS) {	//  ,   0xA
	unsigned int i;					//  160   48
	unsigned char K;				//
	WrCOM(POS);						//  
	for (i = 0; i < 20; i++) {		//    20 
		K = buffer[i];				// 
		if (K>127) K=table[K-128];	//  
		if (K==9) K = 32;			//   
		if (K==0xa) break;			//  0xA -  
		WrDAT(K);	}}				//   
//--------------------------------------------------------------------------------------------------------------------
void WaitLCD(void) {
	unsigned int i;
	for (i = 0; i < 300; i++) {}}	// 75(70).
//--------------------------------------------------------------------------------------------------------------------
const unsigned int table[] = {
    0x41,0xA0,0x42,0xA1,0xE0,0x45,0xA3,0xA4,0xA5,0xA6,0x4B,0xA7,0x4D,0x48,0x4F,0xA8, //8Fh
//   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   H,   ,   
    0x50,0x43,0x54,0xA9,0xAA,0x58,0xE1,0xAB,0xAC,0xE2,0xAD,0xAE,0xC4,0xAF,0xB0,0xB1, //9Fh
//   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   
    0x61,0xB2,0xB3,0xB4,0xE3,0x65,0xB6,0xB7,0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0x6F,0xBE, //AFh
//   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   
    0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20, //BFh
//--------------------------------------------------------------------------------------------------------------------
    0x41,0xA0,0x42,0xA1,0xE0,0x45,0xA3,0xA4,0xA5,0xA6,0x4B,0xA7,0x4D,0x48,0x4F,0xA8, //CFh
//   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   H,   ,   
    0x50,0x43,0x54,0xA9,0xAA,0x58,0xE1,0xAB,0xAC,0xE2,0xAD,0xAE,0xC4,0xAF,0xB0,0xB1, //DFh
//   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   
    0x61,0xB2,0xB3,0xB4,0xE3,0x65,0xB6,0xB7,0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0x6F,0xBE, //EFh
//   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   
	0x70,0x63,0xBF,0x79,0x5C,0x78,0xE5,0xC0,0xC1,0xE6,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7};//FFh
//   p,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   ,   
